function _getInfo(obj){
  var o={};
  o.ind=obj.ind;
  o.enabled=obj.enabled;
  o.count=obj.calcCount();
  o.data=obj.data;
  o.desc=obj.getDesc();
  o.accName=obj.accName;
  o.active=obj.active;
  o.started=obj.started;
  o.iconURL=obj.getIconURL();
  return o;
}
Main.prototype.onRequest=function(data){
  switch(data.cmd){
  case "lastCheck":
    return {cmd:"lastCheck",data:this.lastCheck};
  case "handlers":
    var ar=[];
    for(var i=0;i<this.handlers.length;i++){
      ar.push(_getInfo(this.handlers[i]));
    }
    return {cmd:"handlers",data:ar};
  case "hosts":
    return {cmd:"hosts",data:this.getHosts()};
  case "accounts":
    return {cmd:"accounts",data:this.getAccounts()};
  case "mainHost":
    hostResolver.start(function(host,br,ver){
      opera.extension.broadcastMessage({cmd:"mainHost",host:host,br:br,ver:ver});
    });
    return false;
  case "checkAll":
    this.checkAll();
    return false;
  case "checkNow":
    this.checkNow();
    return false;
  case "openAll":
    this.openViews();
    return false;
  case "click":
    this.onClickAccount(data.ind,data.check);
    return false;
  case "options":
    this.openOptions();
    return false;
  case "init":
    this.init();
    return false;
  case "popupSize":
    if(data.height)tobwithu.button.popup.height=data.height;
    //if(data.width)tobwithu.button.popup.width=data.width;
    return false;
  case "help":
    tobwithu.openTab("http://xnotifier.tobwithu.com/dp/forum/3");
    return false;
  case "closePopup":
    opera.extension.tabs.close(opera.extension.tabs.create({focused:true}));//close popup
    return false;
  case "enterAuth":
    this.enterAuth(data.ind,data.val);
    return false;
  case "enterPwd":
    this.enterPassword(data.ind,data.val,data.save);
    return false;
  case "debug":
    return {cmd:"debug",data:this.debug};
  case "toggleDebug":
    this.toggleDebug();
    return false;
  case "saveLog":
    tobwithu.openTab("data:application/octet-stream,"+encodeURIComponent(this.log));
    return false;
  }
  return false;
}
Main.prototype.openOptions=function(){
  var t=this.getView("options.html");
  if(t){
    t.update({focused:true});
    return;
  }
  opera.extension.tabs.create({url:"options.html",focused:true});
}

Main.prototype.getView=function(url){
  var a=document.createElement("a");
  a.href=url;
  url=a.href;
  var ar=opera.extension.windows.getAll();
  for(var i=0;i<ar.length;i++){
    var tabs=ar[i].tabs.getAll?ar[i].tabs.getAll():ar[i].tabs;
    for(var j=0;j<tabs.length;j++){
      if(tabs[j].url==url)return tabs[j];
    }
  }
  return null;
}
Main.prototype.getTab=function(id){
  var ar=opera.extension.windows.getAll();
  for(var i=0;i<ar.length;i++){
    var tabs=ar[i].tabs.getAll?ar[i].tabs.getAll():ar[i].tabs;
    for(var j=0;j<tabs.length;j++){
      if(tabs[j].id==id)return tabs[j];
    }
  }
  return null;
}
Main.prototype.openView = function(url,id,user,multiId,viewDomain){
  if(typeof url=="object"){//post
    function postHelper(url,data){
      data=atob(data);
      var form = document.createElement("form");
      form.setAttribute("method","post");
      form.setAttribute("action",url);
      var data=data.split("&");
      for(var i=0;i<data.length;i++){
        var f=document.createElement("input");
        var d=data[i].split("=");
        f.setAttribute("type","hidden");
        f.setAttribute("name",d[0]);
        f.setAttribute("value",decodeURIComponent(d[1]));
        form.appendChild(f);
      }
      document.body.appendChild(form);
      form.submit();
    }
    var s="";
    for(var i=0;i<200;i++)s+=" ";
    url="javascript:"+s+postHelper.toString().replace(/(\n|\t)/gm,'')+";postHelper(\""+url[0]+"\",\""+btoa(url[1])+"\")";
  }
  if(multiId!=null)id="-"+id+multiId;
  if(this.tabList[id]){
    var tab=this.getTab(this.tabList[id].tabid);
    if(tab&&this.canReuse(tab.url,viewDomain)){
      tab.update({url:url,focused: true});
    }else{
      tab=opera.extension.tabs.create({url:url,focused:true});
      this.tabList[id]={tabid:tab.id,user:user};
    }
  }else{
    var tab=opera.extension.tabs.create({url:url,focused:true});
    this.tabList[id]={tabid:tab.id,user:user};
  }
}
Main.prototype.setPopupData = function(obj){
  opera.extension.broadcastMessage({cmd:"setPopupData",data:_getInfo(obj)});
}
Main.prototype.setLastCheck=function(){
}
Main.prototype.setLoadingAni = function(ind){
  opera.extension.broadcastMessage({cmd:"loading",ind:ind});
}
Main.prototype.reloadPopup = function(){
  opera.extension.broadcastMessage({cmd:"reloadPopup"});
}

Main.prototype.updateTab = function(o,tabid){
  var tab=this.getTab(this.tabList[tabid].tabid);
  if(tab)tab.update({url:o.getViewURL(),focused: true});
}
Main.prototype._updateCount=function(o){
  o.data.desc=o.getDesc();
  this.setResult(o);
}
Main.prototype._openView=function(o){
  this.updateCount(o);
  this.openView(o.getViewURL(),o.id,o.user,o.multi?o.ind:o.multiId,o.viewDomain);
}
////////////debug////////////////
Main.prototype.toggleDebug=function(){
  this.debug=!this.debug;
  for(i=0;i<this.handlers.length;++i){
    this.handlers[i].debug=this.debug;
  }
}
/////////////////////////////////
function dlog(str,s2){
  var s2=""+s2;
  str=new Date()+"\t"+str+"\t"+(s2.replace(/\r/g,"\\r").replace(/\n/g,"\\n").replace(/\t/g,"\\t"))+"\r\n";
  main.log+=str;
}
