function onResponse(data){
  switch(data.cmd){
  case "connect":
    sendRequest({cmd:"debug"});
    sendRequest({cmd:"lastCheck"});
    sendRequest({cmd:"handlers"});
    break;
  case "lastCheck":
    if(data.data)setLastCheck(data.data);
    break;
  case "handlers":
    init(data.data);
    var em=document.body;
    var em1=document.getElementById("c");
    var h=Math.min(screen.height*3/4,600)-16;
    if(em1.clientHeight>h){
      var em2=document.getElementById("accounts");
      em2.style.height=(em2.clientHeight+h+16-em.scrollHeight)+"px";
      //em.style.width=(260+17)+"px";
      //sendRequest({cmd:"popupSize",height:h+16,width:276+17});
      sendRequest({cmd:"popupSize",height:h+16});
    }else sendRequest({cmd:"popupSize",height:em1.clientHeight+16,width:276});
    break;
  case "loading":
    setLoadingAni(data.ind);
    break;
  case "reloadPopup":
    document.location.reload();
    break;
  case "setPopupData":
    setData(data.data);
    break;
  case "debug":
    if(data.data){
      function saveLog(){
        sendRequest({cmd:"saveLog"});
      }
      $("log").style.display="inherit";
      $("log").addEventListener("click",saveLog);
    }
    break;
  }
}
function init(handlers){
  $("chk").addEventListener("click",checkNow);
  $("open").addEventListener("click",openAll);
  $("options").addEventListener("click",openOptions);
  $("help").addEventListener("click",openHelp);
  var obj=$("accounts");
  for(var i in handlers){
    var o=handlers[i];
    if(o.enabled){
      var n=o.count;
      var em=document.createElement("div");
        em.setAttribute("id",o.ind);
        em.addEventListener("click",function(){
          onClick(this.id,event);
        });

          var em2=document.createElement("div");
          em2.setAttribute("id","i"+o.ind);
          em2.setAttribute("class","icon");
        em.appendChild(em2);

          var em2=document.createElement("pre");
          var em3=document.createTextNode(o.accName);
          em2.appendChild(em3);
        em.appendChild(em2);

          var em2=document.createElement("div");
          em2.setAttribute("id","n"+o.ind);
          em2.setAttribute("class","num");
          var em3=document.createTextNode(n>0?o.desc:"");
          em2.appendChild(em3);
        em.appendChild(em2);

      obj.appendChild(em);
      setData(o);
    }
  }
}
function setLastCheck(d){
  function getS(s){
    if(s.toString().length<2)return "0"+s;
    else return s;
  }
  var ds=getS(d.getHours())+":"+getS(d.getMinutes())
         +":"+getS(d.getSeconds())
  var em=$("chk");
  var att = em.getAttribute('i18n-title');
  var s=tobwithu.i18nString(att);
  if(s)em.setAttribute("title",s+" "+ds);
}
function setData(o){
  var em=$(o.ind);
  if(!em)return;
  var n=o.count;
  em.setAttribute("class","menu"
    +(n>0?" newMsg":"")+(!o.active?" inactive":(n<0?" error":"")));
  em=$("n"+o.ind);
  em.innerText=n>0?o.desc:"";
  em=$("i"+o.ind);
  if(o.started){
    em.style.backgroundImage="url('loading.gif')";
  }else{
    var url=o.iconURL;
    if(n>=0&&url!=null){
      em.style.backgroundImage="url("+url+")";
    }else em.style.backgroundImage="none";
  }
  if(o.data.folders){
    var str=o.accName+(o.count>=0&&o.data.desc?" : "+o.data.desc:"");
    var ar=o.data.folders;
    for(var i=0;i<ar.length;i++){
      str+="\n - "+(ar[i].title?ar[i].title:ar[i].id)+" : "+ar[i].count;
    }
    em=$(o.ind).setAttribute("title",str);
  }
}
function setLoadingAni(ind){
  var em=$("i"+ind);
  if(em)em.style.backgroundImage="url('loading.gif')";
}
window.addEventListener("load",connectMain(onResponse),false);

