tobwithu.loadPrefs=function(name,def){
  var o=localStorage[name];
  if(o==null){
    if(def)o={};
    else return null;
  }else o=JSON.parse(o);
  if(def){
    for(var i in def){
      if(typeof o[i]=="undefined")o[i]=def[i];
    }
  }
  return o;
}
tobwithu.savePrefs=function(name,o){
  localStorage[name]=JSON.stringify(o);
}

tobwithu.loadAccounts=function(){
  if(localStorage["s"]==null)return [];
  var key=localStorage["s"]+"app";
  var ac=localStorage["accounts"];
  if(ac==null)return [];
  var accounts=JSON.parse(ac);  
  for(var i=0;i<accounts.length;i++){
    var o=accounts[i];
    var data=AesCtr.decrypt(o.data,key,256);
    data=data.split("\t");
    if(data.length!=3)continue;
    o.id=data[0];
    o.user=data[1];
    o.password=data[2];
    o.noPwd=o.password=="";
    delete o.data;
    /////////////////////////////////
    o.showFolders=true;
    /////////////////////////////////
    ////delete later/////////////////
    if(o.includeSpam===true)o.includeSpam=2;
    /////////////////////////////////
  }
  return accounts;
}
tobwithu.saveAccounts=function(accounts){
  if(localStorage["s"]==null){
    localStorage["s"]=Math.random().toString().substring(2);  
  }
  var key=localStorage["s"]+"app";
  for(var i=0;i<accounts.length;i++){
    var o=accounts[i];
    o.data=AesCtr.encrypt(o.id+"\t"+o.user+"\t"+o.password,key,256);
    delete o.id;
    delete o.user;
    delete o.password;
    ////delete later/////////////////
    if(o.includeSpam===true)o.includeSpam=2;
    /////////////////////////////////
  }
  localStorage["accounts"]=JSON.stringify(accounts);
}

tobwithu.loadSubScript=function(name,toSrc){
  var str=this.loadFile(name);
  return this.convertSubScript(str,toSrc);
}
tobwithu.convertSubScript=function(str,toSrc){
  var ar=[];
  var rs="";
  while(str){
    var f=str.match(/^([\s\S]*?)(\/\*|\/\/|"|'|\/)([\s\S]*)/);
    if(f){
      if(f[1])rs+=f[1];
      switch(f[2]){
      case "/*":
        var f2=f[3].match(/^[\s\S]*?\*\/([\s\S]*)/);
        if(f2)str=f2[1];
        else str="";
        break;
      case "//":
        var f2=f[3].match(/^[\s\S]*?$([\s\S]*)/m);
        if(f2)str=f2[1];
        else str="";
        break;
      case "\"":
        var f2=f[3].match(/^((?:\\\S|[^"\\])*?")([\s\S]*)/);
        if(f2){
          rs+="'"+ar.length+"'";
          ar.push(f[2]+f2[1]);
          str=f2[2];
        }else str="";
        break;
      case "\'":
        var f2=f[3].match(/^((?:\\\S|[^'\\])*?')([\s\S]*)/);
        if(f2){
          rs+="'"+ar.length+"'";
          ar.push(f[2]+f2[1]);
          str=f2[2];
        }else str="";
        break;
      case "/":
        var f2=f[3].match(/^((?:(?:\[(?:\\\S|[^\]])*?\])|\\\S|[^/])*?\/)([\s\S]*)/);
        if(f2){
          rs+="'"+ar.length+"'";
          ar.push(f[2]+f2[1]);
          str=f2[2];
        }else str="";
        break;
      }
    }else{
      rs+=str;
      break;
    }
  }
  str=rs;
  rs="";
  while(true){
    var ind=str.indexOf("var");
    var ind2=str.indexOf("function");
    if(ind>=0&&((ind2>=0&&ind<ind2)||ind2<0)){
      var fnd=str.match(/var\s+(\S+)\s*=\s*(\S+)\s*;/);
      if(fnd){
        if(rs)rs+=",\n";
        rs+=fnd[1]+":"+fnd[2];
        str=str.substring(ind+fnd[0].length);
      }  
    }else if(ind2>=0){
      var fnd=str.match(/function\s+(\S+)\s*(\([\s\S]*?\))\s*\{/);
      str=str.substring(ind2+fnd[0].length);
      var depth=1;
      var i;
      for(i=0;i<str.length;i++){
        if(str.charAt(i)=="}"){
          --depth;
          if(depth==0){
            if(rs)rs+=",\n";
            rs+=fnd[1]+":function"+fnd[2]+"{"+str.substring(0,i+1);
            str=str.substring(i);
            break;
          }
        }else if(str.charAt(i)=="{")++depth;
      }
    }else break;
  }
  rs=rs.replace(/'(\d+)'/g,function(){return ar[RegExp.$1];});
  if(toSrc)return rs;
  return this.evalSubScript(rs);
}
tobwithu.evalSubScript=function(s){
  eval("tmp={"+s+"}");
  return tmp;
}
tobwithu.loadUserscript=function(id){
  var s=localStorage["scripts."+id];
  return s;
}

tobwithu.loadUserscriptObj=function(id){
  var s=localStorage["scripts."+id];
  if(!s)return null;
  return this.convertSubScript(s);
}
tobwithu.saveUserscript=function(id,s){
  localStorage["scripts."+id]=s;
}